ome-files 0.1.0

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Private Attributes | List of all members
ome::files::out::MinimalTIFFWriter Class Reference

Basic TIFF writer. More...

`#include <ome/files/out/MinimalTIFFWriter.h>`

Inheritance diagram for ome::files::out::MinimalTIFFWriter:
[legend]
Collaboration diagram for ome::files::out::MinimalTIFFWriter:
[legend]

## Public Member Functions
| MinimalTIFFWriter ()
| Constructor.
| MinimalTIFFWriter (const ome::files::detail::WriterProperties &writerProperties)
| Constructor with writer properties (for derived writers).
virtual | ~MinimalTIFFWriter ()
| Destructor.
void | setId (const boost::filesystem::path &id)
| Set the current file name. More...
void | close (bool fileOnly=false)
| Close the currently open file. More...
void | setSeries (dimension_size_type series) const
| Set the active series. More...
void | setPlane (dimension_size_type plane) const
| Set the active plane. More...
void | saveBytes (dimension_size_type plane, VariantPixelBuffer &buf, dimension_size_type x, dimension_size_type y, dimension_size_type w, dimension_size_type h)
| Save an image plane. More...
void | setBigTIFF (boost::optional< bool > big=true)
| Set use of BigTIFF support. More...
boost::optional< bool > | getBigTIFF () const
| Query use of BigTIFF support. More...
Public Member Functions inherited from ome::files::detail::FormatWriter
virtual | ~FormatWriter ()
| Destructor.
bool | isThisType (const boost::filesystem::path &name, bool open=true) const
| Check if the given file is a valid instance of this file format. More...
virtual dimension_size_type | getSeriesCount () const
| Get the number of image series in this file. More...
void | setLookupTable (dimension_size_type plane, const VariantPixelBuffer &buf)
| Set the color lookup table associated with the current series. More...
void | saveBytes (dimension_size_type plane, VariantPixelBuffer &buf)
| Save an image plane. More...
dimension_size_type | getSeries () const
| Get the active series. More...
dimension_size_type | getPlane () const
| Get the active plane. More...
bool | canDoStacks () const
| Get whether or not the writer can save multiple images in a single file. More...
void | setMetadataRetrieve (ome::compat::shared_ptr< ::ome::xml::meta::MetadataRetrieve > &retrieve)
| Set the default metadata store for this writer. More...
const ome::compat::shared_ptr< ::ome::xml::meta::MetadataRetrieve > & | getMetadataRetrieve () const
| Get the current metadata store for this writer. More...
ome::compat::shared_ptr< ::ome::xml::meta::MetadataRetrieve > & | getMetadataRetrieve ()
| Get the current metadata store for this writer. More...
virtual dimension_size_type | getImageCount () const
| Determine the number of image planes in the current series. More...
virtual bool | isRGB (dimension_size_type channel) const
| Does a channel contain subchannels? More...
virtual dimension_size_type | getSizeX () const
| Get the size of the X dimension. More...
virtual dimension_size_type | getSizeY () const
| Get the size of the Y dimension. More...
virtual dimension_size_type | getSizeZ () const
| Get the size of the Z dimension. More...
virtual dimension_size_type | getSizeT () const
| Get the size of the T dimension. More...
virtual dimension_size_type | getSizeC () const
| Get the size of the C dimension. More...
virtual ome::xml::model::enums::PixelType | getPixelType () const
| Get the pixel type. More...
virtual pixel_size_type | getBitsPerPixel () const
| Get the number of valid bits per pixel. More...
virtual dimension_size_type | getEffectiveSizeC () const
| Get the effective size of the C dimension. More...
virtual dimension_size_type | getRGBChannelCount (dimension_size_type channel) const
| Get the number of channels required for a call to saveBytes(). More...
virtual const std::string & | getDimensionOrder () const
| Get the dimension order. More...
virtual dimension_size_type | getIndex (dimension_size_type z, dimension_size_type c, dimension_size_type t) const
| Get the linear index of a `Z`, `C` and `T` coordinate. More...
virtual ome::compat::array< dimension_size_type, 3 > | getZCTCoords (dimension_size_type index) const
| Get the `Z`, `C` and `T` coordinate of a linear index. More...
void | setFramesPerSecond (frame_rate_type rate)
| Set the frame rate to use when writing. More...
frame_rate_type | getFramesPerSecond () const
| Get the frame rate to use when writing. More...
const std::set< ome::xml::model::enums::PixelType > & | getPixelTypes () const
| Get supported pixel types. More...
const std::set< ome::xml::model::enums::PixelType > & | getPixelTypes (const std::string &codec) const
| Get supported pixel types for the given codec. More...
bool | isSupportedType (ome::xml::model::enums::PixelType type) const
| Check if the pixel type is supported. More...
bool | isSupportedType (ome::xml::model::enums::PixelType type, const std::string &codec) const
| Check if the pixel type is supported by the given codex. More...
const std::set< std::string > & | getCompressionTypes () const
| Get supported compression types. More...
void | setCompression (const std::string &compression)
| Set the compression type to use when writing. More...
const boost::optional< std::string > & | getCompression () const
| Get the compression type to use when writing. More...
void | setInterleaved (bool interleaved)
| Set subchannel interleaving. More...
const boost::optional< bool > & | getInterleaved () const
| Set subchannel interleaving. More...
void | changeOutputFile (const boost::filesystem::path &id)
| Switch the output file for the current dataset. More...
void | setWriteSequentially (bool sequential=true)
| Write planes sequentially. More...
bool | getWriteSequentially () const
| Check if planes are written sequentially. More...
const std::string & | getFormat () const
| Get the name of this file format. More...
const std::string & | getFormatDescription () const
| Get the description of this file format. More...
const std::vector< boost::filesystem::path > & | getSuffixes () const
| Get the default file suffixes for this file format. More...
const std::vector< boost::filesystem::path > & | getCompressionSuffixes () const
| Get the default compression suffixes for this file format. More...
Public Member Functions inherited from ome::files::FormatHandler
virtual | ~FormatHandler ()
| Destructor.

## Protected Member Functions
void | nextIFD () const
| Flush current IFD and create new IFD.
void | setupIFD () const
| Set IFD parameters for the current series.
Protected Member Functions inherited from ome::files::detail::FormatWriter
| FormatWriter (const WriterProperties &)
| Constructor.
Protected Member Functions inherited from ome::files::FormatWriter
| FormatWriter ()
| Constructor.
Protected Member Functions inherited from ome::files::FormatHandler
| FormatHandler ()
| Constructor.

## Protected Attributes
ome::common::Logger | logger
| Message logger.
ome::compat::shared_ptr< ome::files::tiff::TIFF > | tiff
| Underlying TIFF file.
ome::compat::shared_ptr< ome::files::tiff::IFD > | ifd
| Current IFD.
dimension_size_type | ifdIndex
| Current plane.
tiff::SeriesIFDRange | seriesIFDRange
| Mapping between series index and start and end IFD as a half-open range.
Protected Attributes inherited from ome::files::detail::FormatWriter
const WriterProperties & | writerProperties
| Writer properties specific to the derived file format.
boost::optional< boost::filesystem::path > | currentId
| The identifier (path) of the currently open file.
ome::compat::shared_ptr< std::ostream > | out
| Current output.
dimension_size_type | series
| Current series.
dimension_size_type | plane
| Current plane.
boost::optional< std::string > | compression
| The compression type to use.
boost::optional< bool > | interleaved
| Subchannel interleaving enabled.
bool | sequential
| Planes are written sequentially.
frame_rate_type | framesPerSecond
| The frames per second to use when writing.
ome::compat::shared_ptr< ::ome::xml::meta::MetadataRetrieve > | metadataRetrieve
| Current metadata store. More...

## Private Attributes
boost::optional< bool > | bigTIFF
| Write a Big TIFF.

## Additional Inherited Members
Public Types inherited from ome::files::FormatWriter
typedef uint16_t | frame_rate_type
| Frame rate type.
Static Public Member Functions inherited from ome::files::FormatHandler
static bool | checkSuffix (const boost::filesystem::path &name, const boost::filesystem::path &suffix)
| Perform suffix matching for the given filename. More...
static bool | checkSuffix (const boost::filesystem::path &name, const std::vector< boost::filesystem::path > &suffixes)
| Perform suffix matching for the given filename. More...
static bool | checkSuffix (const boost::filesystem::path &name, const std::vector< boost::filesystem::path > &suffixes, const std::vector< boost::filesystem::path > &compression_suffixes)
| Perform suffix matching for the given filename. More...
static void | assertId (const boost::optional< boost::filesystem::path > &id, bool notNull=true)
| Assert that the current file is valid. More...

## Detailed Description

Basic TIFF writer.

Note
  Any derived writer which does not implement its own openBytesImpl() must fill `seriesIFDRange`.

## Member Function Documentation

void ome::files::out::MinimalTIFFWriter::close | ( | bool | fileOnly = `false` | ) |
| virtual

Close the currently open file.

An exception may be thrown when closing the file, for example if there are problems flushing any pending writes, or if there are any inconsistencies in the metadata which prevent completing any final writes. The causes are reader- or writer-dependent, and the exception type is dependent upon the implementation details of the reader or writer in use. It is advised to always explicitly close writers, since if this is automatically called at destruction time, any errors will be lost. If an exception is thrown, the object may be left in an inconsistent state and should not be reused.

Parameters

  fileOnly | close the open file only if `true`, or else free all internal state if `false`; only meaningful for readers, since writers will always free all internal state.

Exceptions

  On | error; exception type may vary.

Reimplemented from ome::files::detail::FormatWriter.

References bigTIFF, ome::files::detail::FormatWriter::close(), ifd, ifdIndex, nextIFD(), seriesIFDRange, and tiff.

Referenced by ~MinimalTIFFWriter().

Here is the caller graph for this function:

boost::optional< bool > ome::files::out::MinimalTIFFWriter::getBigTIFF | ( |  | ) | const

Query use of BigTIFF support.

If setBigTIFF has not been used to enable or disable BigTIFF explicitly, BigTIFF support will be disabled by default for data less than 4GiB, unless the data would be larger than 4GiB, in which case it will be enabled by default.

Returns
  `true` if BigTIFF support are enabled, or `false` if disabled.

References bigTIFF.

void ome::files::out::MinimalTIFFWriter::saveBytes | ( | dimension_size_type | plane,
|  | VariantPixelBuffer & | buf,
|  | dimension_size_type | x,
|  | dimension_size_type | y,
|  | dimension_size_type | w,
|  | dimension_size_type | h
| ) |  |
| virtual

Save an image plane.

Write an image plane from a VariantPixelBuffer of size

getSizeX * getSizeY * bytesPerPixel * getRGBChannelCount()

to the current series in the current file.

Parameters

  plane | the plane index within the series.
  buf | the source pixel buffer.
  x | the `X` coordinate of the upper-left corner of the sub-image.
  y | the `Y` coordinate of the upper-left corner of the sub-image.
  w | the width of the sub-image.
  h | the height of the sub-image.

Exceptions

  FormatException | if any of the parameters are invalid.

Implements ome::files::FormatWriter.

References ome::files::FormatHandler::assertId(), ome::files::detail::FormatWriter::currentId, ome::files::detail::FormatWriter::getSeries(), ifd, ifdIndex, ome::files::tiff::ifdIndex(), seriesIFDRange, and setPlane().

void ome::files::out::MinimalTIFFWriter::setBigTIFF | ( | boost::optional< bool > | big = `true` | ) |

Set use of BigTIFF support.

Enable or disable use of BigTIFF support for writing files larger than 4GiB.

Note
  libtiff must be compiled with BigTIFF support enabled for this option to have any effect.

Parameters

  big | `true` to enable or `false` to disable BigTIFF support.

References bigTIFF.

void ome::files::out::MinimalTIFFWriter::setId | ( | const boost::filesystem::path & | id | ) |
| virtual

Set the current file name.

Note this will throw FormatException if there are problems opening the file.

Parameters

  id | the filename to open.

Reimplemented from ome::files::detail::FormatWriter.

References ome::files::tiff::IFDRange::begin, bigTIFF, ome::files::detail::FormatWriter::currentId, ome::files::tiff::IFDRange::end, ome::files::tiff::IFDRange::filename, ome::files::detail::FormatWriter::getImageCount(), ome::files::detail::FormatWriter::getMetadataRetrieve(), ifd, logger, ome::files::detail::FormatWriter::metadataRetrieve, ome::files::pixelSize(), seriesIFDRange, ome::files::FormatHandler::setId(), setupIFD(), ome::files::significantPixelSize(), and tiff.

void ome::files::out::MinimalTIFFWriter::setPlane | ( | dimension_size_type | plane | ) | const
| virtual

Set the active plane.

Parameters

  plane | the plane to activate.

Todo:
  Remove use of stateful API which requires use of plane switching in const methods.

Reimplemented from ome::files::detail::FormatWriter.

References ome::files::detail::FormatWriter::getPlane(), nextIFD(), ome::files::detail::FormatWriter::setPlane(), and setupIFD().

Referenced by saveBytes().

Here is the caller graph for this function:

void ome::files::out::MinimalTIFFWriter::setSeries | ( | dimension_size_type | series | ) | const
| virtual

Set the active series.

Parameters

  series | the series to activate.

Todo:
  Remove use of stateful API which requires use of series switching in const methods.

Reimplemented from ome::files::detail::FormatWriter.

References ome::files::detail::FormatWriter::getSeries(), nextIFD(), ome::files::detail::FormatWriter::setSeries(), and setupIFD().

The documentation for this class was generated from the following files:

- ome/files/out/MinimalTIFFWriter.h
- ome/files/out/MinimalTIFFWriter.cpp